from typing import Iterable

from common.log import LogData
from .base import Transformer


class OutputLogAveragesTransformer(Transformer):
    def transform(self, logs: Iterable[LogData], start_time: float, end_time: float) -> Iterable[LogData]:
        for log in logs:
            if log.logtype != "client-log-averages":
                continue

            with open("log-avgs-{}-{}.txt".format(log.scenario, log.logid), "w") as f:
                f.write("client_count avg med std lat_avg lat_med lat_std\n")
                for e in log.entries():
                    line = [e["client_count"], e["throughput_average"], e["throughput_median"],
                            e["throughput_variance"], e["latency_average"], e["latency_median"],
                            e["latency_variance"]]
                    f.write(" ".join([str(i) for i in line]))

                    f.write("\n")

        return logs
