from typing import Iterable

from common.log import LogData
from .base import Transformer


class OutputLogThroughputTransformer(Transformer):
    def transform(self, logs: Iterable[LogData], start_time: float, end_time: float) -> Iterable[LogData]:
        for log in logs:
            if log.logtype != "client":
                continue

            with open("log-throughput-{}-{}-{}.txt".format(log.scenario, log.logid, log.client_count), "w") as f:
                f.write("time throughput latency latency_min latency_max\n")
                for e in log.entries():
                    if "throughput" not in e:
                        continue
                    line = [e["timestamp"], e["throughput"], e["latency"], e["latency_min"], e["latency_max"]]
                    f.write(" ".join([str(i) for i in line]))
                    f.write("\n")

        return logs
