from typing import Iterable

from common.log import LogData
from .base import Transformer


class OutputRawAvgThroughputTransformer(Transformer):
    def transform(self, logs: Iterable[LogData], start_time: float, end_time: float) -> Iterable[LogData]:
        for log in logs:
            if log.logtype != "client-raw-avg-throughput":
                continue

            with open("raw-avg-throughput-{}-{}.txt".format(log.scenario, log.client_count), "w") as f:
                f.write("tag time throughput latency\n")
                for e in log.entries():
                    line = [e["tag"], e["timestamp"], e["throughput"], e["latency"]]
                    f.write(" ".join([str(i) for i in line]))
                    f.write("\n")

        return logs
