from typing import Iterable

from common.log import LogData
from .base import Transformer


class OutputRawLatenciesTransformer(Transformer):
    def transform(self, logs: Iterable[LogData], start_time: float, end_time: float) -> Iterable[LogData]:
        for log in logs:
            if log.logtype != "client-raw-latencies":
                continue

            with open("raw-latencies-{}-{}.txt".format(log.scenario, log.logid), "w") as f:
                f.write("client_count tag avg med lat_avg lat_50 lat_90\n")
                for e in log.entries():
                    line = [e["client_count"], e["tag"], e["throughput_average"], e["throughput_median"],
                            e["latency_average"], e["latency_50"], e["latency_90"]]
                    f.write(" ".join([str(i) for i in line]))
                    f.write("\n")

        return logs
