from common.errors import printerr
from common.log import LogData
from transformer.base import Filter


class PrintWarningsFilter(Filter):
    def can_handle(self, log: LogData) -> bool:
        return True

    def filter(self, log: LogData, start_time: float, end_time: float) -> LogData:
        ctr = 0
        for entry in log.entries():
            if "warning" not in entry:
                continue
            ctr += 1
            if ctr <= 10:
                printerr(log.source_path, log.logtype, log.logid, entry["warning"])
            elif ctr == 11:
                printerr("... Only showing the first 10 errors")

        return log
