package refit.application.echo;

import java.nio.ByteBuffer;
import java.util.Set;

import refit.application.REFITApplicationServer;
import refit.application.REFITResult;
import refit.message.REFITUniqueID;
import refit.replica.checkpoint.REFITCheckpointObject;
import refit.replica.fuzzycheckpoint.REFITFuzzyCheckpointContainer;

public class REFITEchoServer implements REFITApplicationServer {
	private static final ByteBuffer EMPTY_BUFFER = ByteBuffer.allocate(0);

	@Override
	public void init() {
		// nop
	}

	@Override
	public boolean checkReadOnly(ByteBuffer payload) {
		return false;
	}

	@Override
	public REFITResult processRequest(REFITUniqueID uid, long agreementSeqNr, ByteBuffer payload, boolean createUpdate) {
		return new REFITResult(payload, EMPTY_BUFFER);
	}

	@Override
	public void applyUpdate(ByteBuffer update) {
		// nop
	}

	@Override
	public REFITCheckpointObject[] createCheckpoint() {
		return new REFITCheckpointObject[0];
	}

	@Override
	public void applyCheckpoint(REFITCheckpointObject[] checkpoint) {
		// nop
	}

	@Override
	public Set<?> takeChangelist() {
		throw new UnsupportedOperationException("Not implemented yet");
	}

	@Override
	public REFITCheckpointObject getObject(Object key) {
		throw new UnsupportedOperationException("Not implemented yet");
	}

	@Override
	public REFITFuzzyCheckpointContainer<? extends REFITCheckpointObject, ? extends REFITCheckpointObject> createFuzzyCheckpoint() {
		throw new UnsupportedOperationException("Not implemented yet");
	}

}
