package refit.application.probe;

import refit.application.REFITNopClient;
import refit.application.rezk.REZKTestClientReadWrite;
import refit.client.REFITClientLibrary;
import refit.client.REFITClientThread;
import refit.config.REFITConfig;

public class REFITProbeNopWrapperClient extends REFITClientThread {
	private REFITClientThread innerClient;

	public REFITProbeNopWrapperClient(REFITClientLibrary service) {
		super(service);

		int rawID = service.getNodeID() - REFITConfig.TOTAL_NR_OF_REPLICAS;
		if ((rawID % 2) == 1) {
			innerClient = new REFITNopClient(service);
		} else {
			innerClient = new REZKTestClientReadWrite(service);
		}
	}

	@Override
	protected void work() {
		throw new IllegalStateException("work should not be called for the client wrapper");
	}

	@Override
	public void run() {
		innerClient.run();
	}
}
