package refit.application.rezk.common;

import java.nio.ByteBuffer;


public class REZKStat {
	private static final int HEADER_SIZE = 3 * Integer.BYTES + Long.BYTES;

	public int version;
	public int dataLength;
	public int nrOfChildren;
	public long lastAccess;

	public REZKStat() {
		this.version = -1;
		this.dataLength = -1;
		this.nrOfChildren = -1;
		this.lastAccess = -1;
	}

	public REZKStat(REZKStat stat) {
		copyFrom(stat);
	}


	public void copyFrom(REZKStat src) {
		version = src.version;
		dataLength = src.dataLength;
		nrOfChildren = src.nrOfChildren;
		lastAccess = src.lastAccess;
	}


	// ###########
	// # SETTERS #
	// ###########

	public void setVersion(int version) {
		this.version = version;
	}

	public void setDataLength(int dataLength) {
		this.dataLength = dataLength;
	}

	public void setNrOfChildren(int nrOfChildren) {
		this.nrOfChildren = nrOfChildren;
	}

	public void setLastAccess(long lastAccess) {
		this.lastAccess = lastAccess;
	}

	// ###################################
	// # SERIALIZATION & DESERIALIZATION #
	// ###################################

	public REZKStat(ByteBuffer buffer) {
		this.version = buffer.getInt();
		this.dataLength = buffer.getInt();
		this.nrOfChildren = buffer.getInt();
		this.lastAccess = buffer.getLong();
	}

	public void serialize(ByteBuffer buffer) {
		buffer.putInt(version);
		buffer.putInt(dataLength);
		buffer.putInt(nrOfChildren);
		buffer.putLong(lastAccess);
	}

	public int getSerializedSize() {
		return HEADER_SIZE;
	}

	@Override
	public String toString() {
		return "REZKStat [version=" + version + ", dataLength=" + dataLength + ", nrOfChildren=" + nrOfChildren + ", lastAccess=" + lastAccess + "]";
	}
}
