package refit.application.rezk.datatree;

import java.sql.Connection;
import java.sql.DriverManager;

import refit.application.rezk.REZKServer;
import refit.application.rezk.common.REZKException;


public class REZKMySQLDataTree extends REZKSQLDataTree {

	private static final String DATABASE_DRIVER = "com.mysql.jdbc.Driver";
	private static final String DATABASE_URL_PREFIX = "jdbc:mysql://localhost:3306/";
	private static final String DATABASE_USER = "root";
	private static final String DATABASE_PASSWORD = "";
	private static final String[] DATABASE_INIT_COMMANDS = {
			"DROP TABLE IF EXISTS `" + TABLE_NAME + "`",
			"CREATE TABLE `" + TABLE_NAME + "` (" +
					"`path` varbinary(128) NOT NULL, " +
					"`parent` varbinary(128) NOT NULL, " +
					"`data` varbinary(" + REZKServer.MAXIMUM_DATA_LENGTH + ") DEFAULT NULL, " +
					"`version` int DEFAULT -1, " +
					"`size` int DEFAULT -1, " +
					"`children` smallint DEFAULT -1, " +
					"PRIMARY KEY (`path`), " +
					"KEY (`parent`)" +
					") ENGINE=MyISAM DEFAULT CHARSET=latin1;"
	};

	private final String databaseName;


	public REZKMySQLDataTree(String databaseName) {
		this.databaseName = databaseName;
	}


	@Override
	protected Connection initDatabase() throws REZKException {
		try {
			Class.forName(DATABASE_DRIVER);
			return DriverManager.getConnection(DATABASE_URL_PREFIX + databaseName, DATABASE_USER, DATABASE_PASSWORD);
		} catch (Exception e) {
			e.printStackTrace();
			throw new REZKException(e.getMessage());
		}
	}

	@Override
	protected void initTable() throws REZKException {
		executeBatchCommand(DATABASE_INIT_COMMANDS);
	}

}
