package refit.application.rezk.datatree;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import refit.application.rezk.common.REZKException;

public class REZKSQLOperationContainer {

	public final PreparedStatement CREATE;
	public final PreparedStatement DELETE;
	public final PreparedStatement GET_CHILDREN;
	public final PreparedStatement GET_DATA;
	public final PreparedStatement SET_DATA;
	public final PreparedStatement GET_STAT;
	public final PreparedStatement SET_STAT;
	public final PreparedStatement CHECKPOINT;
	public PreparedStatement CHECKPOINT_FUZZY;
	public PreparedStatement GET_DATA_FUZZY;
	public PreparedStatement GET_STAT_FUZZY;

	public REZKSQLOperationContainer(final Connection database) throws REZKException {
		this.CREATE = prepareStatement(database, REZKSQLOperation.CREATE);
		this.DELETE = prepareStatement(database, REZKSQLOperation.DELETE);
		this.GET_CHILDREN = prepareStatement(database, REZKSQLOperation.GET_CHILDREN);
		this.GET_DATA = prepareStatement(database, REZKSQLOperation.GET_DATA);
		this.SET_DATA = prepareStatement(database, REZKSQLOperation.SET_DATA);
		this.GET_STAT = prepareStatement(database, REZKSQLOperation.GET_STAT);
		this.SET_STAT = prepareStatement(database, REZKSQLOperation.SET_STAT);
		this.CHECKPOINT = prepareStatement(database, REZKSQLOperation.CHECKPOINT);
		this.CHECKPOINT_FUZZY = prepareStatement(database, REZKSQLOperation.CHECKPOINT_FUZZY);
		this.GET_DATA_FUZZY = prepareStatement(database, REZKSQLOperation.GET_DATA);
		this.GET_STAT_FUZZY = prepareStatement(database, REZKSQLOperation.GET_STAT);
	}

	private static PreparedStatement prepareStatement(final Connection database, REZKSQLOperation operation) throws REZKException {
		if (operation.command == null) {
			return null;
		}
		try {
			return database.prepareStatement(operation.command, ResultSet.TYPE_SCROLL_INSENSITIVE);
		} catch (final SQLException sqle) {
			sqle.printStackTrace();
			throw new REZKException(sqle.getMessage());
		}
	}
}
