package refit.client;

import refit.scheduler.REFITSchedulerTask;
import refit.scheduler.REFITSchedulerTaskType;


public abstract class REFITClientTask extends REFITSchedulerTask implements REFITBenchmarkRunnable {

	protected final REFITClientLibrary service;


	public REFITClientTask(REFITClientLibrary service) {
		super(REFITSchedulerTaskType.CLIENT_TASK, service.getGroup());
		this.service = service;
	}

	@Override
	// make progress a public function
	public void progress() {
		super.progress();
	}

	protected abstract void work();

	@Override
	public void execute() {
		boolean shouldWait = service.getPolicy().shouldWaitForMyTurn(service.getNodeID(), this);
		if (shouldWait) return;
		work();
	}
}
