package refit.client;


public abstract class REFITClientThread implements Runnable, REFITBenchmarkRunnable {

	protected final REFITClientLibrary service;


	public REFITClientThread(REFITClientLibrary service) {
		this.service = service;
	}

	protected abstract void work() throws Exception;

	@Override
	public void run() {
		while (!Thread.currentThread().isInterrupted()) {
			try {
				service.getPolicy().waitForMyTurn(service.getNodeID());
				work();
			} catch (Exception e) {
				e.printStackTrace();
				break;
			}
		}
	}

}
