package refit.replica;

import java.util.Arrays;

import refit.config.REFITLogger;
import refit.message.REFITMessage;


public abstract class REFITBaseReplica extends REFITBoundedBaseReplica {
	public REFITBaseReplica(short id, boolean isSingleThreaded, boolean createClientNetwork) {
		super(id, isSingleThreaded, createClientNetwork);
	}

	public void replicaMulticast(REFITMessage message, boolean[] replicas) {
		if (REFITLogger.LOG_COMMUNICATION)
			REFITLogger.logCommunication(this, "send message " + message + " to " + Arrays.toString(replicas));

		for (short i = 0; i < replicas.length; i++) {
			if (i == id) continue;
			if (replicas[i]) network.unicastMessage(message, i);
		}
	}

	public void replicaMulticast(REFITMessage message) {
		replicaMulticast(message, REFITReplicaGroups.getAllReplicas());
	}

	public void replicaUnicast(REFITMessage message, short replicaID) {
		if (REFITLogger.LOG_COMMUNICATION)
			REFITLogger.logCommunication(this, "send message " + message + " to " + replicaID);

		network.unicastMessage(message, replicaID);
	}
}
