package refit.replica.execution;

import refit.message.REFITInstruction.REFITExecutionProgressNotification;
import refit.message.REFITInstruction.REFITSystemNotification;
import refit.message.REFITReply;
import refit.replica.REFITBaseReplica;
import refit.replica.REFITObserver;
import refit.replica.REFITStage;
import refit.replica.checkpoint.REFITCheckpointState;
import refit.replica.fuzzycheckpoint.REFITFuzzyCheckpointNotification;
import refit.replica.order.REFITOrderGroups;
import refit.replica.update.REFITUpdateMessage;
import refit.scheduler.REFITSchedulerTaskType;

public abstract class REFITExecutionStageBase extends REFITStage {

	public final REFITObserver<REFITReply>[] replySenders;
	public final REFITObserver<REFITCheckpointState> checkpointSender;
	public final REFITObserver<REFITUpdateMessage> updateSender;
	public final REFITObserver<REFITFuzzyCheckpointNotification> fuzzyCheckpointNotificationSender;
	public final REFITObserver<REFITSystemNotification> systemSender;
	public final REFITObserver<REFITExecutionProgressNotification> lastSeqNrSender;

	public REFITExecutionStageBase(REFITBaseReplica replica) {
		super(REFITSchedulerTaskType.EXECUTION_STAGE, replica);

		//noinspection unchecked
		replySenders = (REFITObserver<REFITReply>[]) new REFITObserver[REFITOrderGroups.COUNT];
		for (int i = 0; i < replySenders.length; i++) {
			replySenders[i] = new REFITObserver<>();
		}
		checkpointSender = new REFITObserver<>();
		updateSender = new REFITObserver<>();
		fuzzyCheckpointNotificationSender = new REFITObserver<>();
		systemSender = new REFITObserver<>();
		lastSeqNrSender = new REFITObserver<>();
	}
}
