package refit.replica.multichannel;

import refit.message.REFITMessage;
import refit.message.REFITMessageType;
import refit.message.REFITUniqueID;

public class REFITChannelItem extends REFITMessage {
	public final short subChannelID;
	public final REFITMessage content;

	public REFITChannelItem(long seqNr, short subChannelID, REFITMessage content) {
		super(REFITMessageType.CHANNEL_ITEM, new REFITUniqueID((short) -1, seqNr), (short) -1);
		this.subChannelID = subChannelID;
		this.content = content;
	}

	@Override
	public AuthenticationType getAuthenticationType() {
		return AuthenticationType.NOT_SERIALIZABLE;
	}

	@Override
	public String toString() {
		return String.format("{%s|%s|%d|%s}", type, uid, subChannelID, content);
	}
}
