package refit.test;

import java.nio.ByteBuffer;

import refit.agreement.pbft.REFITPBFTMessages.REFITPBFTPrePrepare;
import refit.client.REFITClientLibrary;
import refit.config.REFITConfig;
import refit.message.REFITMessageAuthentication;
import refit.message.REFITRequest;
import refit.message.REFITUniqueID;

public class MACMicrobenchmark {

	public static void main(String[] args) {
		REFITMessageAuthentication mac = new REFITMessageAuthentication((short) 1);

		// empty request
		REFITRequest request = new REFITRequest(new REFITUniqueID((short) 1, 1), (short) 1, (short) -1, -1,
				ByteBuffer.allocate(0), (short) 1, REFITClientLibrary.RequestMode.WRITE);
		request.serializeMessage();

		long counter = 0;
		long mainStart = System.currentTimeMillis();
		long duration = 140 * 1000;

		while (System.currentTimeMillis() - mainStart < duration) {
			final long iterations = 1000000;
			long startTime = System.nanoTime();
			for (int i = 0; i < iterations; i++) {
				REFITPBFTPrePrepare message = new REFITPBFTPrePrepare(counter, 1, request, (short) 1);
				counter++;
				message.serializeMessage();
				mac.appendMulticastMAC(message);
			}
			long endTime = System.nanoTime();
			System.out.println((long) (iterations * REFITConfig.TOTAL_NR_OF_REPLICAS / ((endTime - startTime) / 1e9)) + " MACs / s");
		}
	}
}
