package refit.agreement.weave;

import org.junit.Test;
import refit.agreement.weave.REFITWeaveMessages.REFITWeaveMessageCommit;
import refit.message.MessageHelper;

import static org.junit.Assert.assertArrayEquals;
import static org.junit.Assert.assertEquals;

public class REFITCommitTest {

	private static void assertCommitEquals(REFITWeaveMessageCommit a, REFITWeaveMessageCommit b) {
		MessageHelper.assertBasicsEquals(a, b);
		assertEquals(a.viewID, b.viewID);
		assertArrayEquals(a.getHash(), b.getHash());
	}

	private static void assertCopy(REFITWeaveMessageCommit batch) {
		REFITWeaveMessageCommit batchCopy = MessageHelper.copyMessage(batch, REFITWeaveMessageCommit::new);
		assertCommitEquals(batch, batchCopy);
	}

	@Test
	public void commitSerialization() {
		REFITWeaveMessageCommit commit = createCommit(27);
		assertCopy(commit);
	}

	private static REFITWeaveMessageCommit createCommit(long seqNr) {
		REFITWeaveMessageCommit commit = new REFITWeaveMessageCommit(seqNr, 9, (short) 2);
		commit.serializeMessage();
		return commit;
	}
}
