package refit.application.rezk;

import java.nio.ByteBuffer;
import java.util.Collection;
import java.util.LinkedList;

import refit.application.rezk.common.REZKOperation;
import refit.application.rezk.common.REZKRequest;
import refit.application.rezk.util.REFITByteString;

public class REZKTestDataProvider {
	static Collection<Object[]> createAllREZKRequests() {
		LinkedList<Object[]> parameters = new LinkedList<>();

		Object[] create = new Object[3];
		create[0] = REZKOperation.CREATE;
		REZKRequest createRequest = new REZKRequest(REZKOperation.CREATE, new REFITByteString("/blub"));
		createRequest.setData(new REFITByteString("content").getBytes());
		createRequest.serializeMessage();
		create[2] = createRequest.getBuffer();
		parameters.add(create);

		Object[] delete = new Object[3];
		delete[0] = REZKOperation.DELETE;
		REZKRequest deleteRequest = new REZKRequest(REZKOperation.DELETE, new REFITByteString("/counter"));
		deleteRequest.serializeMessage();
		delete[2] = deleteRequest.getBuffer();
		parameters.add(delete);

		Object[] setData = new Object[3];
		setData[0] = REZKOperation.SET_DATA;
		REZKRequest setRequest = new REZKRequest(REZKOperation.SET_DATA, new REFITByteString("/counter"));
		setRequest.data = new REFITByteString("data").getBytes();
		setRequest.serializeMessage();
		setData[2] = setRequest.getBuffer();
		parameters.add(setData);

		Object[] increment = new Object[3];
		increment[0] = REZKOperation.INCREMENT;
		REZKRequest incrementRequest = new REZKRequest(REZKOperation.INCREMENT, new REFITByteString("/counter"));
		incrementRequest.serializeMessage();
		increment[2] = incrementRequest.getBuffer();
		parameters.add(increment);

		Object[] dequeue = new Object[3];
		dequeue[0] = REZKOperation.DEQUEUE;
		LinkedList<ByteBuffer> dequeuePrepRequests = new LinkedList<>();
		for (int i = 0; i < 5; i++) {
			REZKRequest enqueueRequest = new REZKRequest(REZKOperation.CREATE, new REFITByteString("/queue/element"));
			enqueueRequest.data = new REFITByteString("data" + i).getBytes();
			enqueueRequest.setSequential(true);
			enqueueRequest.serializeMessage();
			dequeuePrepRequests.add(enqueueRequest.getBuffer());
		}
		dequeue[1] = dequeuePrepRequests;
		REZKRequest dequeueRequest = new REZKRequest(REZKOperation.DEQUEUE, new REFITByteString("/queue"));
		dequeueRequest.serializeMessage();
		dequeue[2] = dequeueRequest.getBuffer();
		parameters.add(dequeue);

		return parameters;
	}
}
