package refit.application.rezk.common;

import java.nio.ByteBuffer;

import org.junit.Test;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;


public class REZKStatTest {
	public static void assertStatEquals(REZKStat a, REZKStat b) {
		if (a == null && b == null) return;
		assertFalse(a == null || b == null);
		assertEquals(a.version, b.version);
		assertEquals(a.dataLength, b.dataLength);
		assertEquals(a.nrOfChildren, b.nrOfChildren);
		assertEquals(a.lastAccess, b.lastAccess);
	}

	@Test
	public void stat() {
		REZKStat stat = new REZKStat();
		stat.setDataLength(4);
		stat.setNrOfChildren(2);
		stat.setVersion(42);
		stat.setLastAccess(((long) Integer.MAX_VALUE) * 3);

		ByteBuffer buffer = ByteBuffer.allocate(stat.getSerializedSize());
		stat.serialize(buffer);
		buffer.flip();

		REZKStat statMod = new REZKStat(buffer);
		assertFalse(buffer.hasRemaining());
		assertStatEquals(stat, statMod);

		REZKStat statCopy = new REZKStat(stat);
		assertStatEquals(stat, statCopy);
	}
}
