package refit.replica.multichannel;

import org.junit.Test;
import refit.message.MessageHelper;
import refit.message.REFITMessageType;

import static org.junit.Assert.assertArrayEquals;

public class REFITChannelAckTest {

	private static void assertAckEquals(REFITChannelAck a, REFITChannelAck b) {
		MessageHelper.assertBasicsEquals(a, b);
		assertArrayEquals(a.changedSubChannels, b.changedSubChannels);
		assertArrayEquals(a.changedAcks, b.changedAcks);
	}

	private static void assertCopy(REFITChannelAck ack) {
		REFITChannelAck ackCopy = MessageHelper.copyMessage(ack, (bb) -> new REFITChannelAck(REFITMessageType.CHANNEL_ACK, bb));
		assertAckEquals(ack, ackCopy);
	}

	@Test
	public void ackSerialization() {
		REFITChannelAck ack = createAck();
		assertCopy(ack);
	}

	private static REFITChannelAck createAck() {
		return new REFITChannelAck(REFITMessageType.CHANNEL_ACK, 42, (short) 1, new short[]{1, 2, 3}, new long[]{4, 5, 6});
	}
}
